#include <stdio.h>
#include <stdlib.h>

FILE *input;
unsigned int *data;
unsigned char line[2000];

int w,h,nc;

unsigned int colors[256];

#define MAGIC  "ASIMG.1"

void bad_input()
{
  fprintf(stderr,"bad input image\n");
  exit(1);
}

int get_line()
{
  int i;
again:
  if (!fgets(line,2000,input)) return 0;
  line[1999]= 0;
  for(i=0;line[i];i++) if (line[i]=='\r' || line[i]=='\n') { line[i]=0; break; }
  for(i=0;line[i];i++) if (!isspace(line[i])) break;
  if (!line[i]) goto again;
  return 1;
}

int main(int argc,char **argv)
{
  int i,j,k;

  if (argc>1)
  {
   input= fopen(argv[1],"rb");
   if (!input) exit(fprintf(stderr,"can't open %s\n",argv[1]));
  }
  else
   input= stdin;

  if (!get_line()) bad_input();
  if (strcmp(line,MAGIC)) bad_input();

  if (!get_line()) bad_input();
  if (sscanf(line,"%d%d%d",&w,&h,&nc)!=3) bad_input();

  for(i=0;i<nc;i++)
  {
   if (!get_line()) bad_input();
   k= line[0];
   colors[k]= strtoul(line+1,NULL,16); 
  }

  printf("%d | (1<<31), %d,",w,h);

  data= malloc(sizeof(data[0])*w*h);

  for(i=0;i<h;i++)
  {
    if (!get_line()) break;
    for(j=0;j<w;j++)
      if (line[j]) printf("0x%08x,", colors[line[j]]);
      else break;
    for(;j<w;j++) printf("0,");
  }
  for(;i<h;i++)
    for(j=0;j<w;j++)
      printf("0,");
  printf("\n");
  return 0;
}
