#!/bin/sh

cd library/build
echo '--------------------------------------'
echo '        Building the Library          '
echo '--------------------------------------'
jj || exit 1

Target=X11

echo '--------------------------------------'
echo "        Compiling for $Target         "
echo '--------------------------------------'

case "$Target" in
   Android)
       CC=arm-linux-androideabi-gcc ;
       CFLAGS='-DGFX_ANDROID -DGFX_ANDROID_ACTIVITY="com/dodo/easyprint/MyActivity"';;
   X11)
       CC=gcc ; 
       CFLAGS="-g -DGFX_X11";;
   FB)
       CC=gcc ;
       CFLAGS="-g -DGFX_FB";;
   *) echo unknown target $Target ; exit 1;;
esac

$CC -o gfx.o -c gfx.c $CFLAGS -Wall -D_XX_WIDGETS_START=20 \
   -D_XX_WIDGETS_END=50  || exit 1

echo '--------------------------------------'
echo "             ALL OK"
echo '--------------------------------------'
